package org.xbib.jdbc.connection.pool.util;

import java.util.concurrent.TimeUnit;

public class NanosecondClockSource implements ClockSource {

    public NanosecondClockSource() {
    }

    @Override
    public long currentTime0() {
        return System.nanoTime();
    }

    @Override
    public long toMillis0(final long time) {
        return TimeUnit.NANOSECONDS.toMillis(time);
    }

    @Override
    public long toNanos0(final long time) {
        return time;
    }

    @Override
    public long elapsedMillis0(final long startTime) {
        return TimeUnit.NANOSECONDS.toMillis(System.nanoTime() - startTime);
    }

    @Override
    public long elapsedMillis0(final long startTime, final long endTime) {
        return TimeUnit.NANOSECONDS.toMillis(endTime - startTime);
    }

    @Override
    public long elapsedNanos0(final long startTime) {
        return System.nanoTime() - startTime;
    }

    @Override
    public long elapsedNanos0(final long startTime, final long endTime) {
        return endTime - startTime;
    }

    @Override
    public long plusMillis0(final long time, final long millis) {
        return time + TimeUnit.MILLISECONDS.toNanos(millis);
    }

    @Override
    public TimeUnit getSourceTimeUnit0() {
        return TimeUnit.NANOSECONDS;
    }
}
