package org.xbib.io.pool.jdbc.mock;

import org.xbib.io.pool.jdbc.PoolTestExtension;
import java.sql.Array;
import java.sql.Blob;
import java.sql.CallableStatement;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.NClob;
import java.sql.PreparedStatement;
import java.sql.SQLClientInfoException;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.SQLXML;
import java.sql.Savepoint;
import java.sql.Statement;
import java.sql.Struct;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.Executor;
import java.util.concurrent.atomic.AtomicInteger;

public class StubConnection extends StubBaseConnection implements Connection {

    public static final AtomicInteger count = new AtomicInteger();

    public static volatile boolean slowCreate;

    public static volatile boolean oldDriver;

    private static final long foo;

    private boolean autoCommit;

    private int isolation = Connection.TRANSACTION_READ_COMMITTED;

    private String catalog;

    static {
        foo = System.currentTimeMillis();
    }

    public StubConnection() {
        count.incrementAndGet();
        if (slowCreate) {
            PoolTestExtension.quietlySleep(1000);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    public <T> T unwrap(Class<T> iface) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }

        if (iface.isInstance(this)) {
            return (T) this;
        }

        throw new SQLException("Wrapped connection is not an instance of " + iface);
    }

    @Override
    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return false;
    }

    @Override
    public CallableStatement prepareCall(String sql) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return null;
    }

    @Override
    public String nativeSQL(String sql) throws SQLException {
        return null;
    }

    @Override
    public void setAutoCommit(boolean autoCommit) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        this.autoCommit = autoCommit;
    }

    @Override
    public boolean getAutoCommit() throws SQLException {
        return autoCommit;
    }

    @Override
    public void commit() throws SQLException {

    }

    @Override
    public void rollback() throws SQLException {

    }

    @Override
    public void close() throws SQLException {

    }

    @Override
    public boolean isClosed() throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return false;
    }

    @Override
    public DatabaseMetaData getMetaData() throws SQLException {
        return null;
    }

    @Override
    public void setReadOnly(boolean readOnly) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
    }

    @Override
    public boolean isReadOnly() throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return false;
    }

    @Override
    public void setCatalog(String catalog) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        this.catalog = catalog;
    }

    @Override
    public String getCatalog() throws SQLException {
        return catalog;
    }

    @Override
    public void setTransactionIsolation(int level) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        this.isolation = level;
    }

    @Override
    public int getTransactionIsolation() throws SQLException {
        return isolation;
    }

    @Override
    public SQLWarning getWarnings() throws SQLException {
        return null;
    }

    @Override
    public void clearWarnings() throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
    }

    @Override
    public Statement createStatement(int resultSetType, int resultSetConcurrency) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return null;
    }

    @Override
    public PreparedStatement prepareStatement(String sql, int resultSetType, int resultSetConcurrency) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return new StubPreparedStatement(this);
    }

    @Override
    public CallableStatement prepareCall(String sql, int resultSetType, int resultSetConcurrency) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return null;
    }

    @Override
    public Map<String, Class<?>> getTypeMap() throws SQLException {
        return null;
    }

    @Override
    public void setTypeMap(Map<String, Class<?>> map) throws SQLException {
    }

    @Override
    public void setHoldability(int holdability) throws SQLException {
    }

    @Override
    public int getHoldability() throws SQLException {
        return (int) foo;
    }

    @Override
    public Savepoint setSavepoint() throws SQLException {
        return null;
    }

    @Override
    public Savepoint setSavepoint(String name) throws SQLException {
        return null;
    }

    @Override
    public void rollback(Savepoint savepoint) throws SQLException {
    }

    @Override
    public void releaseSavepoint(Savepoint savepoint) throws SQLException {
    }

    @Override
    public Statement createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return null;
    }

    @Override
    public PreparedStatement prepareStatement(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return new StubPreparedStatement(this);
    }

    @Override
    public CallableStatement prepareCall(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return null;
    }

    @Override
    public PreparedStatement prepareStatement(String sql, int autoGeneratedKeys) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return new StubPreparedStatement(this);
    }

    @Override
    public PreparedStatement prepareStatement(String sql, int[] columnIndexes) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return new StubPreparedStatement(this);
    }

    @Override
    public PreparedStatement prepareStatement(String sql, String[] columnNames) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return new StubPreparedStatement(this);
    }

    @Override
    public Clob createClob() throws SQLException {
        return null;
    }

    @Override
    public Blob createBlob() throws SQLException {
        return null;
    }

    @Override
    public NClob createNClob() throws SQLException {
        return null;
    }

    @Override
    public SQLXML createSQLXML() throws SQLException {
        return null;
    }

    @Override
    public boolean isValid(int timeout) throws SQLException {
        if (throwException) {
            throw new SQLException();
        }
        return true;
    }

    @Override
    public void setClientInfo(String name, String value) throws SQLClientInfoException {
    }

    @Override
    public void setClientInfo(Properties properties) throws SQLClientInfoException {
    }

    @Override
    public String getClientInfo(String name) throws SQLException {
        return null;
    }

    @Override
    public Properties getClientInfo() throws SQLException {
        return null;
    }

    @Override
    public Array createArrayOf(String typeName, Object[] elements) throws SQLException {
        return null;
    }

    @Override
    public Struct createStruct(String typeName, Object[] attributes) throws SQLException {
        return null;
    }

    public void setSchema(String schema) throws SQLException {
    }

    public String getSchema() throws SQLException {
        return null;
    }

    public void abort(Executor executor) throws SQLException {
        throw new SQLException("Intentional exception during abort");
    }

    public void setNetworkTimeout(Executor executor, int milliseconds) throws SQLException {
    }

    public int getNetworkTimeout() throws SQLException {
        if (oldDriver) {
            throw new AbstractMethodError();
        }

        return 0;
    }

}
